/*RSBAC global network client
 *
 *(c) Stanislav Ievlev <inger@linux.ru.net>
 */
 
/*r-job.c - jobs client. Interactive version*/

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <netdb.h>
#include <string.h>

#include <r-job.h>
#include <r-job-lib.h>
#include <auth.h>


char keyword[MAX_LINE]; /*password to work*/

char session_keyword[MAX_LINE]; /*session keyword*/

/*main work*/
int main(int argc, char *argv[])
{
    int i;
    int s;	/*connection socket*/
    char command_str[MAX_LINE];
    char super_str[MAX_LINE];
    
/*check args*/
    if (argc<3){
	printf("Usage: r-job host job args\n");
	printf("  host     - RSBAC server host\n");
	printf("  job  - command you want to run\n");
	exit(1);
    }

/*make command_str*/
    strncpy(command_str,argv[2],MAX_LINE);
    for (i=3;i<argc;i++){
        strncat(command_str," ",MAX_LINE);
	strncat(command_str,argv[i],MAX_LINE);
    }
    
/*get password from user*/
    get_keyword(keyword,0);

/*make connection*/
    s=client_connection(argv[1]);    
/*send password*/
    client_check_keyword(s,keyword,session_keyword);

/*send command to server*/
    strncpy(super_str,GET_AND_ADD_COMMAND,MAX_LINE);    
    client_write_command(s,super_str);
/*send job to server*/
    client_write_message(s,command_str,session_keyword);
/*receive and execute commands from server*/
    client_read_message(s,session_keyword,1,0);

/*close connection*/
    close(s);
    
    return (0);
}