#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "r-job.h"
#include "r-job-lib.h"

#define PROC_FILE "/proc/meminfo"
#define SLEEP_TIMEOUT 2

int main(int argc, char *argv[])
{
    FILE *f=NULL;
    char command_str[MAX_LINE],data_str[MAX_LINE],
    keyword[MAX_LINE],session_keyword[MAX_LINE];
    
    int sleep_time=SLEEP_TIMEOUT;
    int s,ch;

    char *find=NULL;
    char *hostname=NULL;

    /*check args*/
    while ((ch = getopt(argc, argv, "h:t:")) != EOF)
	switch((char)ch)
	{
	    case 't':		/* Local User */
		    sleep_time = strtol(optarg,0,0);
		    break;
	    case 'h':           /*Host for connection*/
		    hostname=optarg;
		    break;
	}

    /*analize options*/
    if (hostname == NULL) {
        hostname=malloc(MAX_LINE);
        strncpy(hostname,DEFAULT_HOST,MAX_LINE);
    }
    
    /*get keyword*/
    get_keyword(keyword,1);    

/*main working cicle*/
    while(1){
	f=fopen(PROC_FILE,"r");
        if (f==NULL){/*check for errors*/
	    perror("open proc file");
	    exit(1);
	} 
	fgets(data_str,MAX_LINE,f);/*get first string*/
	fgets(data_str,MAX_LINE,f);/*get second string*/
	
	find=strchr(data_str,':'); /*find Mem:*/
	if (find==NULL){/*check for errors*/
	    perror("cannot find \':\'");
	    exit(1);
	}
	
	find+=3; /*little shift*/
	strncpy(data_str,find,MAX_LINE);
	
#ifdef TEST
	fprintf(stderr,">>%s\n",data_str);
#endif
	/*make command_str*/
	strncpy(command_str,ADD_ONLY_MINE_COMMAND,MAX_LINE); /*We add data to itself job-list*/
	/*create connection*/
	s=client_connection(hostname);
	/*send password*/
	client_check_keyword(s,keyword,session_keyword);
	/*send command to server*/
	client_write_command(s,command_str);
	/*send results to server*/
	client_write_message(s,data_str,session_keyword);
	
	close(s);
	sleep(sleep_time); /*sleep some time*/
  }/*while*/

    return(0);
}