/*RSBAC global network
 *
 *(c) Stanislav Ievlev <inger@linux.ru.net>
 */

/*robd-conf.c - jobs server.Some work with config file*/

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <netdb.h>
#include <syslog.h>
#include <signal.h>
#include <string.h>

#include "r-job.h"
#include "r-job-d.h"
#include "auth.h"

extern char *hostname; /*slave host*/
extern char *clientlist_filename; /*station list file*/
extern char *job_filename; /*pattern for job-file name*/
extern char *log_filename; /*log file name*/
extern char *errlog_filename; /*err log file name*/

/*delete spaces before and after string*/
void del_space(char *line)
{
    int i=0,j=0;
    char *tmpstr=NULL;

    tmpstr=line;
    /*first spaces*/
    while ((line[i++]==' ')&&(i<strlen(line))) tmpstr++;
    if (i>=strlen(line)) return;
    strncpy(line,tmpstr,MAX_LINE);
    
    /*last spaces*/    
    i=strlen(line)-1;
    while ((line[i--]==' ')&&(i>0)) j++;
    if(i==0) return;
    line[strlen(line)-j]=0;
}

void parse_config(char *config_file)
{
    FILE *f=NULL;
    char config_line[MAX_LINE];
    char *tmp_line=NULL;
    char *find=NULL;

    f=fopen(config_file,"r");
    if (f==NULL){
    perror("Cannot open config file");
    exit(1);
    }
    
    while (fgets(config_line,MAX_LINE,f)!=NULL){
    
    
    if (config_line[0]=='#') continue; /*we don't need comments*/
    
    del_space(config_line); /*clear line*/
    
    find=strchr(config_line,':');
    if (find==NULL) continue; /*strange line*/
    find++;
    tmp_line=malloc(MAX_LINE);
    strncpy(tmp_line,find,MAX_LINE);
    
    if (tmp_line[strlen(tmp_line)-1]==10)
	tmp_line[strlen(tmp_line)-1]=0;
    
    
    del_space(tmp_line); /*clear line*/

#ifdef TEST
//    fprintf(stderr,"config>>%s<<\n",tmp_line);
#endif
//    fprintf(stderr,"config.old>>%s<<",config_line);
    
    if (strstr(config_line,ACTIVITY_LOG_CONFIG)!=NULL)
    log_filename=tmp_line;

    if (strstr(config_line,ERROR_LOG_CONFIG)!=NULL)
    errlog_filename=tmp_line;

    if (strstr(config_line,JOB_NAME_CONFIG)!=NULL)
    job_filename=tmp_line;

    if (strstr(config_line,STATION_LIST_CONFIG)!=NULL)
    clientlist_filename=tmp_line;
    
    }
    
    fclose(f);
}